#! /usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from numpy import *
from pylab import *
import matplotlib.pyplot as plt
import glob
import pdb
b = pdb.set_trace

def main(h,cases):
 	dirNameList = cases
 	# figure line colors
	col = matplotlib.cm.gist_rainbow
 	dirNameList.sort()
 	print "\nPlotting the following cases:"
 	print dirNameList

	hSample = 10
 
 	dirNameLegend = range(len(dirNameList))
 	for i, dirName in enumerate(dirNameList):
		# finding the most converged run.
  		setName =  glob.glob(dirName + '/sets/*')
  		lastRun = range(len(setName))

  		for num in range(len(setName)):
   			lastRun[num] = int(setName[num][setName[num].rfind("/")+1:])
  		m = max(lastRun)
  		p = lastRun.index(m)
  		# output to screen of convergence data
  		if not(m % 10):
   			print dirName + " did not converge, after " + str(m) + " iterations the error is TODO"
  		else:
   			print dirName + " converged after " + str(m) + " iterations"

		# x line
  		data_h = genfromtxt(setName[p] + '/line_h_U.xy',delimiter=' ')
  		x, Ux_h, Uy_h  = data_h[:,0], data_h[:,1], data_h[:,2] 

		# z line
  		data_z = genfromtxt(setName[p] + '/line_y_U.xy',delimiter=' ')
  		z, Ux_z, Uy_z  = data_z[:,0], data_z[:,1], data_z[:,2] 
		z = z-h # normalizing data to height of hill-top above ground

		# inlet
  		data_inlet = genfromtxt(setName[p] + '/line_inlet_U.xy',delimiter=' ')
  		z_inlet, Ux_inlet, Uy_inlet  = data_inlet[:,0], data_inlet[:,1], data_inlet[:,2] 

  		# calculating S_x
		Ux_inlet_hSample = interp(hSample,z_inlet,Ux_inlet)
		print "Ux_inlet_hSample = " , Ux_inlet_hSample, " m/s"
		Sx = (Ux_h - Ux_inlet_hSample)/Ux_inlet_hSample
		
		# calculating S_z
		Sz = (Ux_z - interp(z,z_inlet,Ux_inlet))/interp(z,z_inlet,Ux_inlet)

		# calculating normolized TKE_x
		data_h_k = genfromtxt(setName[p] + '/line_h_epsilon_k_nut_p.xy',delimiter=' ')
		k = data_h_k[:,2]
		TKEn = k/(Ux_inlet_hSample**2)
		
		# plotting sample lines and acceleration numbers

		# plotting S_x
  		fig1 = figure(1)
		plt.plot(x,Sx,color=col(i/2.,1))
		plt.grid(which='major')
  		plt.grid(which='minor')
  		plt.hold(True)
  		plt.title('Sx for h = ' + str(hSample) + ' meters' )
  		plt.ylabel('Sx')
		# adding Martinez results
		data_Martinez_2D = genfromtxt('Fig32a_2D.csv',delimiter=' ')
		x_Martinez_2D, Sx_Martinez_2D = data_Martinez_2D[:,0], data_Martinez_2D[:,1]
		plt.plot(x_Martinez_2D,Sx_Martinez_2D,'r+')
		data_Martinez_3D = genfromtxt('Fig32a_3D.csv',delimiter=' ')
		x_Martinez_3D, Sx_Martinez_3D = data_Martinez_3D[:,0], data_Martinez_3D[:,1]
		plt.plot(x_Martinez_3D,Sx_Martinez_3D,'bo')

		
		# plotting TKE_x
		fig2 = figure(2)
		plt.plot(x,TKEn,color=col(i/2.,1))
		plt.grid(which='major')
  		plt.grid(which='minor')
  		plt.hold(True)
  		plt.title('TKEn for h = ' + str(hSample) + ' meters' )
  		plt.ylabel('TKEn')
  		plt.xlabel('Horizontal coordinate [m]')
		# adding Martinez results
		dataTKE_Martinez_2D = genfromtxt('Fig32b_2D.csv',delimiter=' ')
		xTKE_Martinez_2D, TKEx_Martinez_2D = dataTKE_Martinez_2D[:,0], dataTKE_Martinez_2D[:,1]
		plt.plot(xTKE_Martinez_2D,TKEx_Martinez_2D,'r+')
		dataTKE_Martinez_3D = genfromtxt('Fig32b_3D.csv',delimiter=' ')
		xTKE_Martinez_3D, TKEx_Martinez_3D = dataTKE_Martinez_3D[:,0], dataTKE_Martinez_3D[:,1]
		plt.plot(xTKE_Martinez_3D,TKEx_Martinez_3D,'bo')

		# plotting S_y
		fig3 = figure(3)
		plt.semilogy(Sz,z,color=col(i/2.,1))
		plt.grid(which='major')
  		plt.grid(which='minor')
  		plt.hold(True)
  		plt.title('Sz above hill center' )
  		plt.xlabel('Sz')
  		plt.ylabel('Vertical coordinate [m]')
		dirNameLegend[i] = dirName
		
	
	dirNameLegend = (dirName,'Martinez 2D','Martinez 3D')
	fig1 = figure(1)
	plt.legend(dirNameLegend,loc=0)
	fig1.set_facecolor('w')
	plt.savefig('fig1.png')
	fig2 = figure(2)
	plt.legend(dirNameLegend,loc=0)
	fig2.set_facecolor('w')
	plt.savefig('fig2.png')
	fig3 = figure(3)
	plt.legend(dirNameLegend,loc=0)
	fig3.set_facecolor('w')
	plt.savefig('fig3.png')
 	plt.show()

if __name__ == '__main__':
	# reading arguments
	n = len(sys.argv)
	h = float(sys.argv[1])
	cases = sys.argv[2:]
	main(h,cases)
